//////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////
// IStbTddext.h
// (C) Copyright 1998 by STB Systems, Inc.
//
//////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////
#ifndef __ISTBTDDEXT_H__
#define __ISTBTDDEXT_H__

#ifndef STB_COM_OBJECT
DEFINE_GUID(CLSID_STBTDDExtension, 0x9f645d50, 0x14fa,0x11d2,0x8f, 0x78, 0x00, 0xa0, 0xc9, 0x82, 0xc6, 0x1a);

DEFINE_GUID(IID_ISTBTDDSurfaceExt, 0x9f645d2c, 0x14fa,0x11d2,0x8f, 0x78, 0x00, 0xa0, 0xc9, 0x82, 0xc6, 0x1a);

#endif

struct ISTBTDDSurfaceExt;

typedef struct ISTBTDDSurfaceExt	FAR *LPTULSASURFACEEXT;
typedef struct _SURFACEDESCEXT		FAR *LPSURFACEDESCEXT;
typedef struct _FILLSURFACECMD		FAR *LPFILLSURFACECMD;

typedef struct _DEBUG_SURFACE_INFO	FAR *LPDEBUG_SURFACE_INFO;
typedef struct _DEBUG_SCROLL_INFO FAR *LPDEBUG_SCROLL_INFO;

//////////////////////////////////////////////////////////////////////////
//  ITulsaSurfaceExt
//////////////////////////////////////////////////////////////////////////
#undef INTERFACE
#define INTERFACE ISTBTDDSurfaceExt
DECLARE_INTERFACE_( ISTBTDDSurfaceExt, IUnknown )
{
    /*** IUnknown methods ***/
    STDMETHOD(QueryInterface) (THIS_ REFIID riid, LPVOID FAR * ppvObj) PURE;
    STDMETHOD_(ULONG,AddRef) (THIS)  PURE;
    STDMETHOD_(ULONG,Release) (THIS) PURE;
    /*** ITulsaSurfaceExt methods ***/
    STDMETHOD(AssignSurface)(THIS_ LPDIRECTDRAWSURFACE) PURE;
    STDMETHOD(UpdateOverlay)(THIS_ LPRECT, LPDIRECTDRAWSURFACE,LPRECT,DWORD, LPDDOVERLAYFX, LPSURFACEDESCEXT) PURE;
    STDMETHOD(GetSurfaceDescExt)(THIS_ LPSURFACEDESCEXT) PURE;
    STDMETHOD(SetSurfaceDescExt)(THIS_ LPSURFACEDESCEXT) PURE;
	STDMETHOD(StartFlickerFilter)(THIS_ LPPOINT,LPSIZE,HANDLE) PURE;
	STDMETHOD(StopFlickerFilter)(THIS) PURE;
	STDMETHOD(GetFlickerFilterStatus)(THIS_ LPBOOL, LPDWORD) PURE;
	STDMETHOD(SuspendUpdates)(THIS_ BOOL) PURE;
	STDMETHOD(SetYUVToRGBCoefficients)(THIS_ DWORD) PURE;
	STDMETHOD(FillSurface)(THIS_ LPFILLSURFACECMD) PURE;
	STDMETHOD(GetGraphicsLoading)(THIS_ LPDWORD) PURE;
	STDMETHOD(GetSurfaceInfo)(THIS_ LPDEBUG_SURFACE_INFO, DWORD, LPDWORD) PURE;
	STDMETHOD(GetScrollDebugInfo)(THIS_ LPDEBUG_SCROLL_INFO) PURE;
	STDMETHOD(StartFlickerFilterEx)(THIS_ LPPOINT,LPSIZE,HANDLE,BOOL) PURE;
};


//
// SURFACEDESCEXT - Surface Description Extension
//
typedef struct _SURFACEDESCEXT {
	DWORD dwSize;					// Size of this structure
	DWORD dwFlags;					// Specifies which options to enable
	LONG  lScrollPixelsPerStep;		// Number of pixels per scrolling step (signed)
	DWORD dwScrollVerticalsPerStep;	// Number of vertical periods between scrolling steps
	DWORD dwScrollPausePosition;	// Position where scrolling should pause - use value outside of
									//  source overlay size range to not pause scrolling
	DWORD dwScrollPosition;			// Current position of scroll window within source overlay
	DWORD dwScrollNotifIncrement;	// Number of pixels between scrolling handshakes
	HANDLE hScrollEvent;			// Event to use for scrolling handshaking
	BOOL bPreserveDestAlpha;		// If TRUE, then don't write alpha of this surface to a dest
									//  surface when this surface is used as an overlay
	BOOL bInvertAlpha;				// If TRUE, then invert interpretation of alpha value
	DWORD dwScrollNotifPosition;	// Position at which a notification should be given
} SURFACEDESCEXT, *LPSURFACEDESCEXT;


// dwFlags
#define SDE_SCROLL_VERT			0x00000001	// Scroll vertically
#define SDE_SCROLL_HORZ			0x00000002  // Scroll horizontally
#define SDE_SCROLL_SET_SRC_POS	0x00000004	// Set the source position as specified by dwScrollPosition
#define SDE_SCROLL_NOTIFY		0x00000008	// Notify application via hScrollEvent at each scroll notification position and/or increment
#define SDE_SCROLL_NOTIFY_RESET	0x00000010	// Reset notification counter

//
// FILLSURFACECMD - Fill-Surface Command Description
//
typedef struct _FILLSURFACECMD {
	DWORD dwSize;					// Size of this structure
	DWORD dwFlags;					// Specifies which options to enable
	DWORD dwExecCount;				// Number of verticals to execute (0xffffffff -> always)
	DWORD dwMask;					// Mask to use when filling
	DWORD dwRed;					// Starting red value (16.16 format)
	DWORD dwAlpha;					// Starting alpha value (16.16 format)
	DWORD dwGreen;					// Starting green value (16.16 format)
	DWORD dwBlue;					// Starting blue value (16.16 format)
	DWORD dwRedDx;					// Delta in x direction for red value (16.16 format)
	DWORD dwAlphaDx;				// Delta in x direction for alpha value (16.16 format)
	DWORD dwGreenDx;				// Delta in x direction for green value (16.16 format)
	DWORD dwBlueDx;					// Delta in x direction for blue value (16.16 format)
	DWORD dwRedDy;					// Delta in y direction for red value (16.16 format)
	DWORD dwAlphaDy;				// Delta in y direction for alpha value (16.16 format)
	DWORD dwGreenDy;				// Delta in y direction for green value (16.16 format)
	DWORD dwBlueDy;					// Delta in y direction for blue value (16.16 format)
	DWORD dwRedDvert;				// Delta per vertical for red value (16.16 format)
	DWORD dwAlphaDvert;				// Delta per vertical for alpha value (16.16 format)
	DWORD dwGreenDvert;				// Delta per vertical for green value (16.16 format)
	DWORD dwBlueDvert;				// Delta per vertical for blue value (16.16 format)
} FILLSURFACECMD, *LPFILLSURFACECMD;

// dwFlags
#define FSC_ENABLE	0x00000001		// Set to enable fill



//For debug only

typedef struct _DEBUG_SURFACE_INFO {
	DWORD m_dwOddBase;
	DWORD m_dwEvenBase;
	DDSURFACEDESC m_SurfaceDesc;
	SURFACEDESCEXT m_SurfaceDescExt;
	BOOL m_bFieldsInterleeved;
	BOOL m_bPrimary;
	DWORD m_CommandCount;
} DEBUG_SURFACE_INFO, *PDEBUG_SURFACE_INFO;


typedef struct _DEBUG_SCROLL_INFO {
	DWORD NotifyCount;
} DEBUG_SCROLL_INFO, *PDEBUG_SCROLL_INFO;


#endif // __ISTBTDDEXT_H__